#!/usr/bin/perl
open (OFILE, ">babel.bzw") || die ("Can't open output file\n");
print OFILE <<EOT;
# Pinball
#
# by His Blind Ambition  (jbum\@jbum.com)
#
#
#
EOT


MakeZiggerat(0,0,300,4.1,4.0,20.0,40.0);

#teleporter on roof
MakeTeleporter(10,10,300,10,30,45,1);	  # 0,1

#teleporter on bottom
MakeTeleporter(0,0,0,10,30,45,1);	      # 2,3

# teleporters on corners
MakeTeleporter(340,340,0,10,30,45,1);	  # 4,5
MakeTeleporter(-340,-340,0,10,30,45,1);	# 6,7
MakeTeleporter(340,-340,0,10,30,-45,1);	# 8,9
MakeTeleporter(-340,340,0,10,30,-45,1);	# 10,11

my $nc = 40;
my $step = 2*3.14159/$nc;
my $dstep = 360/$nc;
my $ang1 =   0;
my $ang2 = 120*2*3.14159/360;
my $ang3 = 240*2*3.14159/360;
foreach (0..$nc-1)
{
	my $x = cos($_ * $step)*100;
	my $y = sin($_ * $step)*100;
	my $t = 4.0+sin($_ * $step);
	my $h = 15;
	MakeColumn($x,$y,0,$t,$h,($_+$nc/4) * $dstep);
	MakeColumn($x+sin($ang1)*150,$y+cos($ang1)*150,0,$t,$h,($_+$nc/4) * $dstep);
	MakeColumn($x+sin($ang2)*150,$y+cos($ang2)*150,0,$t,$h,($_+$nc/4) * $dstep);
	MakeColumn($x+sin($ang3)*150,$y+cos($ang3)*150,0,$t,$h,($_+$nc/4) * $dstep);
}

MakeLink(0,3);
MakeLink(1,2);
MakeLink(2,0);
MakeLink(3,1);
MakeLink(4,0);
MakeLink(5,6);
MakeLink(6,2);
MakeLink(7,4);
MakeLink(8,1);
MakeLink(9,10);
MakeLink(10,3);
MakeLink(11,8);

close OFILE;
exit;

sub MakeZiggerat()
{
	my ($ox,$oy,$desiredMaxRad,$startHeight,$hinc,$pathWidth,$spikeHeight) = @_;

	my $tw = $pathWidth;  # path width
	my $s = int($desiredMaxRad*2/$tw);  # units per side - start even
	my $h = $startHeight;
	my $wallHeight = 4;
	my $f = 0;
	my $sh = .5;  # step height
	my $wallAdj = 0;
	my $fh = 2;		# wallheight
	
	while ($s > 0) {
		# s is even
		PrintBox($ox-$tw/2, $oy-(($s/2)*$tw), $h-$sh,	$tw*$s/2, $tw, $sh, 0); # bot step
		PrintBox($ox-$tw/2, $oy-(($s/2)*$tw-$tw*$wallAdj), $f,	$tw*$s/2, $tw/8, ($h-$sh)-$f, 0); # bot wall
		MakeSpike($ox-($s/2)*$tw, $oy-($s/2)*$tw, $h, $pathWidth/3,$spikeHeight);

		$h += $hinc;
		$f = $h-$hinc*$fh<0? 0 : $h-$hinc*$fh;

		PrintBox($ox+$tw*($s/2), $oy-$tw/2, $h-$sh,	$tw, $tw*$s/2, $sh, 0);		# right step
		PrintBox($ox+$tw*($s/2)-$tw*$wallAdj, $oy-$tw/2, $f,	$tw/8, $tw*$s/2, ($h-$sh)-$f, 0);		# right wall
		MakeSpike($ox+$tw*($s/2), $oy-($s/2)*$tw, $h, $pathWidth/3,$spikeHeight);

		$h += $hinc;
		$f = $h-$hinc*$fh<0? 0 : $h-$hinc*$fh;
		$s--;  
		# s is now odd

		PrintBox($ox+$tw, $oy+$tw*(($s+1)/2),$h-$sh, $tw*$s/2.0, $tw, $sh, 0);	# top step
		PrintBox($ox+$tw, $oy+$tw*(($s+1)/2)-$tw*$wallAdj,$f, $tw*$s/2.0, $tw/8, ($h-$sh)-$f, 0);	# top wall
		MakeSpike($ox+$tw*($s-1)/2, $oy+(($s+1)/2)*$tw, $h, $pathWidth/3,$spikeHeight);

		$h += $hinc;
		$f = $h-$hinc*$fh<0? 0 : $h-$hinc*$fh;

		PrintBox($ox-$tw*($s-1)/2,$oy+$tw,$h-$sh,	$tw, $tw*$s/2.0, $sh, 0);		# left step
		PrintBox($ox-($tw*($s-1)/2-$tw*$wallAdj),$oy+$tw,$f,	$tw/8, $tw*$s/2.0, ($h-$sh)-$f, 0);		# left wall
		MakeSpike($ox-$tw*($s-1)/2, $oy+(($s+1)/2)*$tw, $h, $pathWidth/3,$spikeHeight);

		$h += $hinc;
		$f = $h-$hinc*$fh<0? 0 : $h-$hinc*$fh;
		$s--;  
		# s is now even again
	}
}

sub MakeSpike()
{
	my ($x,$y,$z,$w,$h) = @_;
	PrintPyramid($x,$y,$z,$w/2,$w/2,$h,-45/2.0);
	PrintPyramid($x,$y,$z,$w/2,$w/2,$h,+45/2.0);
}

sub MakeColumn($$$$$)
{
	my ($x,$y,$z,$colthick,$coltall,$r) = @_;

	my $baseheight = 0;
	my $captall = $colthick/5.0;
	my $capwide = $coltall/3.0;

	PrintBox($x,$y,$z,$colthick/2,$colthick/4,$baseheight+$coltall-$captall,$r+0);
	PrintBox($x,$y,$z,$colthick/2,$colthick/4,$baseheight+$coltall-$captall,$r+60);
	PrintBox($x,$y,$z,$colthick/2,$colthick/4,$baseheight+$coltall-$captall,$r-60);
	PrintBox($x,$y,$z+$baseheight+$coltall-$captall,
								$colthick/2+$capwide,$colthick/2+$capwide,$captall,$r);
}

sub PrintBox()
{
	my ($x,$y,$z,$xs,$ys,$zs,$r) = @_;
	printf OFILE "box\n";
	printf OFILE "position %7.3f %7.3f %7.3f\n",$x,$y,$z;
	printf OFILE "rotation %7.3f\n",$r;
	printf OFILE "size %7.3f %7.3f %7.3f\n",$xs,$ys,$zs;
	printf OFILE "end\n\n";
}

sub PrintPyramid($$$$$$)
{
	my ($x,$y,$z,$xs,$ys,$zs, $r) = @_;

	printf OFILE "pyramid\nposition %6.3f %6.3f %6.3f\nrotation %6.3f\nsize %6.3f %6.3f %6.3f\nend\n\n",
							$x,$y,$z,$r,$xs,$ys,$zs;
}

sub MakeTeleporter($$$$$$)
{
	my ($x,$y,$z,$w,$h,$rot,$b) = @_;
	printf OFILE "teleporter\nposition %6.3f %6.3f %6.3f\nrotation %6.3f\nsize 0 %6.3f %6.3f\nborder %d\nend\n\n",
							$x,$y,$z,$rot,$w,$h,$b;
}



sub MakeLink($$)
{
	my ($from,$to) = @_;
	printf OFILE "link\nfrom %d\nto %d\nend\n\n",$from,$to;
}
