# Make HexTile
#
open (OFILE, ">hextile.bzw") || die ("Can't open output file\n");
print OFILE <<EOT;
# Hex Maniax
#
# by His Blind Ambition
#
EOT

my $nx = 5;
my $ny = 4;
my $ar  = 60*3.14159/180;
my $ar2 = 30*3.14159/180;
my $r = 500/$nx;                            # radius
my $s = $r;  																# length of side
my $r2 = $r * sqrt(.75);										# r to side bisector
my $r75 = $r * 0.75;														# r to point where midpoint bisector crosses r

print "r = $r  s = $s  r2 = $r2\n";

my $xOfst = -($r*(3*int($nx/2)))/2; # work on this for centering
my $yOfst = -($r*2*$ny-$r*2)/2; # work on this for centering
my $xd = $r+$s/2;
my $yd = $r2*2;
my $rads = 3.14159/180;
my @xAng = (cos(0*$rads),cos(60*$rads),cos(120*$rads),cos(180*$rads),cos(240*$rads),cos(300*$rads));
my @yAng = (sin(0*$rads),sin(60*$rads),sin(120*$rads),sin(180*$rads),sin(240*$rads),sin(300*$rads));


MakePaths(12,16);
MakePaths(24,10);
MakePaths2(36,4);
MakeCones(2,90);

close OFILE;
exit;

sub MakeCones($$)
{
	my ($rad,$h)=@_;

	foreach my $x (0..$nx-1)
	{
		my $mmx = $x*$xd + $xOfst;
		foreach my $y (0..$ny-1)
		{
			my $mmy = $y*$yd + $yOfst;
			$mmy += $r2 if ($x & 1) > 0;
			PrintPyramid($mmx,$mmy,0,$rad,$rad,$h,int(rand()*360));
		}
	}
}

sub MakePaths($$)
{
	my ($h,$pw) = @_;
	foreach my $x (0..$nx-1)
	{
		my $mmx = $x*$xd + $xOfst;
		foreach my $y (0..$ny-1)
		{
			my $mmy = $y*$yd + $yOfst;
			$mmy += $r2 if ($x & 1) > 0;
			my $tile = int(rand()*5);
			if ($tile == 0) {
				PrintBox($mmx+$xAng[1]*$r75, $mmy+$yAng[1]*$r75,$h-1,	 $r2/2,$pw,1,-30);
				PrintBox($mmx+$xAng[3]*$r75, $mmy+$yAng[3]*$r75,$h-1,	 $r2/2,$pw,1,90);
				PrintBox($mmx+$xAng[5]*$r75, $mmy+$yAng[5]*$r75,$h-1,	 $r2/2,$pw,1,30);
			}
			elsif ($tile == 1) {
				PrintBox($mmx+$xAng[2]*$r75, $mmy+$yAng[2]*$r75,$h-1,	 $r2/2,$pw,1,30);
				PrintBox($mmx+$xAng[4]*$r75, $mmy+$yAng[4]*$r75,$h-1,	 $r2/2,$pw,1,-30);
				PrintBox($mmx+$xAng[0]*$r75, $mmy+$yAng[0]*$r75,$h-1,	 $r2/2,$pw,1,90);
			}
			elsif ($tile == 2) {
				PrintBox($mmx,$mmy,$h-1, $r2,$pw,1,30);
				PrintBox($mmx+$xAng[2]*$r75, $mmy+$yAng[2]*$r75,$h-1,	 $r2/2,$pw,1,30);
				PrintBox($mmx+$xAng[5]*$r75, $mmy+$yAng[5]*$r75,$h-1,	 $r2/2,$pw,1,30);
			}
			elsif ($tile == 3) {
				PrintBox($mmx,$mmy,$h-1, $r2,$pw,1,-30);
				PrintBox($mmx+$xAng[1]*$r75, $mmy+$yAng[1]*$r75,$h-1,	 $r2/2,$pw,1,-30);
				PrintBox($mmx+$xAng[4]*$r75, $mmy+$yAng[4]*$r75,$h-1,	 $r2/2,$pw,1,-30);
			}
			elsif ($tile == 4) {
				PrintBox($mmx,$mmy,$h-1, $r2,$pw,1,90);
				PrintBox($mmx+$xAng[0]*$r75, $mmy+$yAng[0]*$r75,$h-1,	 $r2/2,$pw,1,90);
				PrintBox($mmx+$xAng[3]*$r75, $mmy+$yAng[3]*$r75,$h-1,	 $r2/2,$pw,1,90);
			}
		}
	}
}


sub MakePaths2($$)
{
	my ($h,$pw) = @_;
	foreach my $x (0..$nx-1)
	{
		my $mmx = $x*$xd + $xOfst;
		foreach my $y (0..$ny-1)
		{
			my $mmy = $y*$yd + $yOfst;
			$mmy += $r2 if ($x & 1) > 0;
			my $tile = int(rand()*5);
			if ($tile == 0) {
				PrintBox($mmx+$xAng[1]*$r75, $mmy+$yAng[1]*$r75,$h-1,	 $r2/2,$pw,1,-30);
				PrintBox($mmx+$xAng[3]*$r75, $mmy+$yAng[3]*$r75,$h-1,	 $r2/2,$pw,1,90);
				PrintBox($mmx+$xAng[5]*$r75, $mmy+$yAng[5]*$r75,$h-1,	 $r2/2,$pw,1,30);
			}
			elsif ($tile == 1) {
				PrintBox($mmx+$xAng[2]*$r75, $mmy+$yAng[2]*$r75,$h-1,	 $r2/2,$pw,1,30);
				PrintBox($mmx+$xAng[4]*$r75, $mmy+$yAng[4]*$r75,$h-1,	 $r2/2,$pw,1,-30);
				PrintBox($mmx+$xAng[0]*$r75, $mmy+$yAng[0]*$r75,$h-1,	 $r2/2,$pw,1,90);
			}
			elsif ($tile == 2) {
				PrintBox($mmx,$mmy,0, $r2,$pw,$h,30);
				PrintBox($mmx+$xAng[2]*$r75, $mmy+$yAng[2]*$r75,$h-1,	 $r2/2,$pw,1,30);
				PrintBox($mmx+$xAng[5]*$r75, $mmy+$yAng[5]*$r75,$h-1,	 $r2/2,$pw,1,30);
			}
			elsif ($tile == 3) {
				PrintBox($mmx,$mmy,0, $r2,$pw,$h,-30);
				PrintBox($mmx+$xAng[1]*$r75, $mmy+$yAng[1]*$r75,$h-1,	 $r2/2,$pw,1,-30);
				PrintBox($mmx+$xAng[4]*$r75, $mmy+$yAng[4]*$r75,$h-1,	 $r2/2,$pw,1,-30);
			}
			elsif ($tile == 4) {
				PrintBox($mmx,$mmy,0, $r2,$pw,$h,90);
				PrintBox($mmx+$xAng[0]*$r75, $mmy+$yAng[0]*$r75,$h-1,	 $r2/2,$pw,1,90);
				PrintBox($mmx+$xAng[3]*$r75, $mmy+$yAng[3]*$r75,$h-1,	 $r2/2,$pw,1,90);
			}
		}
	}
}



sub PrintBox($$$$$$$)
{
	my ($x,$y,$z,$xs,$ys,$zs,$r) = @_;
	printf OFILE "box\n";
	printf OFILE "position %7.3f %7.3f %7.3f\n",$x,$y,$z;
	printf OFILE "rotation %7.3f\n",$r;
	printf OFILE "size %7.3f %7.3f %7.3f\n",$xs,$ys,$zs;
	printf OFILE "end\n\n";
}

sub PrintPyramid($$$$$$)
{
	my ($x,$y,$z,$xs,$ys,$zs, $r) = @_;

	printf OFILE "pyramid\nposition %6.3f %6.3f %6.3f\nrotation %6.3f\nsize %6.3f %6.3f %6.3f\nend\n\n",
							$x,$y,$z,$r,$xs,$ys,$zs;
}

sub MakeTeleporter($$$$$$)
{
	my ($x,$y,$z,$w,$h,$rot,$b) = @_;
	printf OFILE "teleporter\nposition %6.3f %6.3f %6.3f\nrotation %6.3f\nsize 0 %6.3f %6.3f\nborder %d\nend\n\n",
							$x,$y,$z,$rot,$w,$h,$b;
}

sub MakeLink($$)
{
	my ($from,$to) = @_;
	print OFILE <<EOT;
link
from $from
to   $to
end
EOT
}
