#!/usr/bin/perl
use strict;

open (OFILE, ">platforms.bzw") || die ("Can't open platforms for output");
print OFILE <<EOT;
# Platforms
#
# by His Blind Ambition  (jbum\@jbum.com)
#
#
#
EOT

my $i;
my $n = 16; # number of platforms

foreach $i (0..$n-1)
{
	my $if = ($i+3)/($n+2);
	my $ang = 4*3.14159*$if;
	my $rad = 390*$if;
	my $high = 50+200*$if;
	MakeTeleporter($rad*sin($ang),$rad*cos($ang),0,8,30,-($ang*180/3.14159),1);
	MakeTeleplatform($rad*sin($ang),$rad*cos($ang),(($i & 1) > 0? 180 : 0)-($ang*180/3.14159),$high);		# NE
}

foreach $i (0..$n-1)
{
	MakeLink($i*4,$i*4+2);
	MakeLink($i*4+1,$i*4+3);
	MakeLink($i*4+2,(($i+1)*4+2)%($n*4));
	MakeLink((($i+1)*4+3)%($n*4),$i*4+3);
}


close OFILE;
# END

sub MakeTeleplatform($$$$)
{
	my ($x,$y,$r,$h) = @_;
	MakeStar($x,$y,$h,15,1,$r);
	MakeTeleporter($x,$y,$h+1,8,20,$r,1);
}


sub MakeStar($$$$$$)
{
	my ($x,$y,$h,$w,$tall,$r) = @_;
	PrintMazeBox($x,$y,$h,$w,$w,$tall,$r);
	PrintMazeBox($x,$y,$h,$w*2,$w/4,$tall,($r+45)%360);
	PrintMazeBox($x,$y,$h,$w*2,$w/4,$tall,($r+360-45)%360);
}


sub PrintMazeBox($$$$$$)
{
	my ($x,$y,$z,$xs,$ys,$zs, $r) = @_;
	printf OFILE "box\nposition %6.3f %6.3f %6.3f\nrotation %6.3f\nsize %6.3f %6.3f %6.3f\nend\n\n",
							$x,$y,$z,$r,$xs,$ys,$zs;
}

sub PrintMazePyr($$$$$$)
{
	my ($x,$y,$z,$xs,$ys,$zs, $r) = @_;

	printf OFILE "pyramid\nposition %6.3f %6.3f %6.3f\nrotation %6.3f\nsize %6.3f %6.3f %6.3f\nend\n\n",
							$x,$y,$z,$r,$xs,$ys,$zs;
}

sub MakeTeleporter($$$$$$)
{
	my ($x,$y,$z,$w,$h,$rot,$b) = @_;
	printf OFILE "teleporter\nposition %6.3f %6.3f %6.3f\nrotation %6.3f\nsize 0 %6.3f %6.3f\nborder %d\nend\n\n",
							$x,$y,$z,$rot,$w,$h,$b;
}

sub MakeLink($$)
{
	my ($from,$to) = @_;
	print OFILE <<EOT;
link
from $from
to   $to
end
EOT
}
