#!/usr/bin/perl
use strict;

open (OFILE, ">rings.bzw") || die ("Can't open ringmaze for output");

print OFILE <<EOT;
# Cloud Cuckoo Land
#
# by His Blind Ambition  (jbum\@jbum.com)
#
#
#
EOT

foreach my $i (0..13) { # do the columns if lower than 6
	my $oRad = 20+$i*20;
	my $pHeight = 140-$i*10;
	my $iPHeight = 20+$i*10;
	MakeRing($oRad,($i==0? 10 : 20),$pHeight,2,$i < 6);  # at h=50, orad=180
	if ($i != 6 && $i != 0) {
		MakeRing($oRad,($i==0? 10 : 20),$iPHeight,2,$i > 6);  # h=100, orad=140
	}
}

foreach my $i (0..12) {  # do the columns if higher than 6
	
	next if $i == 6;
	my $oRad = 20+$i*20;
}

foreach my $i (0..4) {  # 4 is last ground one, the last 2 produce an illusion
	my $w = 7+7*$i;
	my $h = 20-5*$i;
	MakeStar(0,0,$h,$w,5);
}


# PrintMazePyr(0,0,20,2,2,40,0);
# PrintMazePyr(0,0,20,2,2,40,45);

# MakeRing(20,
my $teleH = 400;

MakeTeleporter(0,0,$teleH,10,10,0);

MakeTeleplatform(340,340,45,$teleH);		# NE
MakeTeleplatform(340,-340,-45,$teleH);	# SE
MakeTeleplatform(-340,340,-45,$teleH);	# NW
MakeTeleplatform(-340,-340,45,$teleH);	# SW

MakeTeleplatform(-340/2,0,0,$teleH);
MakeTeleplatform(340/2,0,0,$teleH);
MakeTeleplatform(0,340/2,90,$teleH);
MakeTeleplatform(0,-340/2,90,$teleH);
MakeTeleporter(0,0,20,10,$teleH-20,0);

MakeLink(0,1);
MakeLink(1,0);

foreach my $i (1..4) {
	MakeLink($i*2,0);
	MakeLink($i*2+1,0);
}

foreach my $i (5..9) {
	MakeLink($i*2,$i*2);
	MakeLink($i*2+1,$i*2+1);
}


# END

sub MakeStar($$$$$)
{
	my ($x,$y,$h,$w,$tall) = @_;
	PrintMazeBox($x,$y,$h,$w,$w,$tall,0);
	PrintMazeBox($x,$y,$h,$w,$w,$tall,45);
}


sub MakeRing($$$$$)
{
	my ($cenRad, $pathWid, $lowerHeight, $pathTall, $wantsPillars) = @_;
	PrintMazeBox(-$cenRad,0,$lowerHeight,$pathWid/2,$cenRad+$pathWid/2,$pathTall,0);
	PrintMazeBox($cenRad,0,$lowerHeight,$pathWid/2,$cenRad+$pathWid/2,$pathTall,0);
	PrintMazeBox(0,$cenRad,$lowerHeight,$cenRad-$pathWid/2,$pathWid/2,$pathTall,0);
	PrintMazeBox(0,-$cenRad,$lowerHeight,$cenRad-$pathWid/2,$pathWid/2,$pathTall,0);
	if ($wantsPillars) {
		PrintColumn( $cenRad, $cenRad,3,$lowerHeight);
		PrintColumn( $cenRad,-$cenRad,3,$lowerHeight);
		PrintColumn(-$cenRad, $cenRad,3,$lowerHeight);
		PrintColumn(-$cenRad,-$cenRad,3,$lowerHeight);
	}
}

sub PrintColumn($$$$)
{
	my ($x,$y,$rad,$height) = @_;
	PrintMazeBox($x,$y,0,$rad,$rad,$height,0);
	PrintMazeBox($x,$y,0,$rad,$rad,$height,45);
	
	PrintMazePyr($x,$y,0,$rad+2,$rad+2,10,0);
	PrintMazePyr($x,$y,0,$rad+2,$rad+2,10,45);
	
	PrintMazePyr($x,$y,$height+2,$rad-1,$rad-1,30,0);
	PrintMazePyr($x,$y,$height+2,$rad-1,$rad-1,30,45);
}

sub PrintMazeBox($$$$$$)
{
	my ($x,$y,$z,$xs,$ys,$zs, $r) = @_;

	print OFILE <<EOT;
box
position  $x $y $z
rotation  $r
size      $xs $ys $zs
end

EOT
}

sub PrintMazePyr($$$$$$)
{
	my ($x,$y,$z,$xs,$ys,$zs, $r) = @_;

	print OFILE <<EOT;
pyramid
position  $x $y $z
rotation  $r
size      $xs $ys $zs
end

EOT
}

sub MakeTeleplatform($$$$)
{
	my ($x,$y,$r,$h) = @_;
	MakeStar($x,$y,0,20,1);
	MakeTeleporter($x,$y,1,10,$h,$r);
}

sub MakeTeleporter($$$$$$)
{
	my ($x,$y,$z,$w,$h,$rot) = @_;
print OFILE <<EOT;
teleporter
position      $x $y $z
rotation      $rot
size          0 $w $h
border        0
end
EOT
}

sub MakeLink($$)
{
	my ($from,$to) = @_;
	print OFILE <<EOT;
link
from $from
to   $to
end
EOT
}
