#!/usr/bin/perl

# map rotator
use strict;

my $timeLimit = 60*30;                  # 30 minutes
my $sAddr = '66.229.146.1';
my $port = 5158;
my $rport = 5157;

my $globServOpts = "-requireudp -synctime -lagwarn 500 "   # require udp, synchronize time of day, lagwarn
                   . "-passwd boing "
									 . "-r -st 5 -sw 1 "           # allow rogue, shake bad flags in 5 secs, shake bad flags in 1 win
									 . "-fb -mo 2 -j +r "				   #  allow flags on boxes, max observers, allow jump, rico
									 . "-mp 8 -mts 1000 -mps 200 " # maximum players 10, max team score, max player score
                   . "-t -g ";                   # allow teleporters, one game only, time limit


#
my $defServOpts =   "-ms 4 "            # maxshots 4
                  . "+s 10 "            # always have # superflags
                  . "-s 10 "            # allow up to # superflags
                  . "-f R -f JP -f bad " # inhibit these flags, add these
                  . "+f GM +f ST +f ST +f SR +f L +f ID +f SW +f CL +f SB +f OO +f G +f PZ +f SH +f T +f N +f F +f IB +f V +f A +f MG +f JM +f B +f M +f CB +f WA";

my @servList = ({world => 'hobbes.bzw',  name => 'Calvin and Hobbes: Hobbes\' World'},
								{world => 'parthworld.bzw', name => 'Parthenon: Tanks invade the Acropolis!',
										opts => '-ms 3 +s 10 -s 10 -f R -f JP -f bad -f GM -f L'},								
		 						{world => 'calvin.bzw',  name => 'Calvin and Hobbes: Calvin\'s World'},
								{world => 'quad.bzw',    name => 'IKEA Quadrophenia',
										cmds => ['perl makequad.pl']},
		 						{world => 'babel.bzw',  name => 'Tower of Babel'},
								{world => 'ok.bzw',     name => 'Tankfight at the O.K. Corral - Old West Rules!',
								    opts => '-ms 1 -f bad'},
								{world => 'hexworld.bzw', name => 'Hex Maniax: Lasers, Cloak, Stealth, Steamroller',
										cmds => ['perl makehextile.pl','copy hextile.bzw+platforms.bzw hexworld.bzw'],
										opts => '-ms 3 +s 10 -s 10 -f bad +f ST +f ST +f L +f L +f CL +f SR +f SR'},
		 						{world => 'dobbsex.bzw', name => 'Slackworld: Church of the Subgenius'},
								{world => 'rings.bzw',  name => 'Cloud Cuckoo Land'},
							  );
my $snbr = int(rand() * @servList);
while (1) {
	my $serv = $servList[$snbr];
	$snbr = ($snbr+1) % @servList;
	my $nextServStr = $servList[$snbr]->{name};
	printf "%s: Running %s\n", scalar localtime, $serv->{name};
	if (defined $serv->{cmds}) {
		# apply server commands, if necessary
		foreach my $cmd (@{$serv->{cmds}})
		{
			print "--> $cmd\n";
			print `$cmd`;
		}
	}
	my $servOpts = (defined $serv->{opts})? $serv->{opts} : $defServOpts;
	my $bzsCmd = "bzfs -world $serv->{world} -p $port -pr $rport -publicaddr $sAddr:$port ";
		 $bzsCmd .= "-public \"$serv->{name}\" ";
		 $bzsCmd .= "-publiclist bzflist://166.70.15.250/ ";
		 $bzsCmd .= "-admsg \"[ Next map: $nextServStr - server resets when everyone leaves ]\" ";
		 $bzsCmd .= "-srvmsg \"$serv->{name} - your host: His Blind Ambition (jbum\@jbum.com)\" ";
		 $bzsCmd .= "$globServOpts $servOpts";
	my $res = `$bzsCmd`;
	print "$res\nGame over\n\n";
}